#TEMPLATE(InternetLink,'Internet Link Template'),FAMILY('ABC'),FAMILY('CW20')
#!
#EXTENSION(InternetLinkGlobal,'Internet Link Global Template'),APPLICATION,LAST
#!
#SHEET
#TAB('Internet Link Global Template 1.0')
#BOXED('')
#DISPLAY('')
#DISPLAY('The Internet Link Global Template will allow')
#DISPLAY('you to create Internet Hyperlinks in your app')
#DISPLAY('Application.')
#DISPLAY('')
#PROMPT('Include SHELLEXECUTE API',CHECK),%PTSIncludeShell, Default(1),AT(10,,,)
#DISPLAY('')
#ENDBOXED
#ENDTAB
#ENDSHEET
#! ----------------------------------------------------------------
#AT(%GlobalMap)
  #PROJECT('hand.cur')
  URLHandler(unsigned, STRING)
  #IF(%PTSIncludeShell)
  MODULE('winstuff')
    #IF (%Target32)
      ShellExecute(UNSIGNED,LONG,*CSTRING,LONG,*CSTRING,SIGNED),UNSIGNED,PASCAL,RAW,NAME('SHELLEXECUTEA')
    #ELSE
      ShellExecute(UNSIGNED,LONG,*CSTRING,LONG,*CSTRING,SIGNED),UNSIGNED,PASCAL,RAW
    #ENDIF
  END
  #ENDIF
#ENDAT
#! ----------------------------------------------------------------
#AT(%ProgramProcedures)
URLHandler              PROCEDURE (wHandle, URL)                   ! Declare Procedure
URLBuffer            CSTRING(256)
EmptyString          CSTRING(254)
  CODE                                                          ! Begin processed code
    URLBuffer = CLIP(URL)
    EmptyString=''
    x#=ShellExecute(whandle, 0, URLBuffer, 0, EmptyString, 1)
#ENDAT
#!----------------------------------------------------------------
#EXTENSION(InternetLinkCreator,'Create Internet Links'),PROCEDURE, LAST
#BOXED('')
#DISPLAY('Insert controls to use as your Internet Links')
#DISPLAY('Good candidates are String and Image controls.')
#PROMPT('Create Controls Starting At:',@N_5),%ILControlStart,DEFAULT(100)
#BUTTON ('Internet Link Controls'), MULTI(%ILControls, %ILControl), INLINE
#PROMPT('Internet Link Control:',CONTROL),%ILControl
#PROMPT('Parent Control:',CONTROL),%ILParent
#PROMPT('Link To',OPTION),%ILLinkTo
#PROMPT('HTML/FTP',RADIO)
#PROMPT('E-Mail',RADIO)
#PROMPT('Address:',@S200),%ILAddress
#DISPLAY('Use a ! in front of a variable.')
#ENDBUTTON
#ENDBOXED

#ATSTART
#DECLARE(%ILControlNumber)
#DECLARE(%InternetVar)
#ENDAT

#AT (%AfterWindowOpening)
DO CreateILControls
#ENDAT

#AT (%AcceptLoopBeforeFieldHandling)
DO InternetLinkEvents
#ENDAT


#AT(%ProcedureRoutines)
CreateILControls    ROUTINE                !Create HyperLink Regions
#SET(%ILControlNumber,%ILControlStart)
#FOR(%ILControls)
   CREATE(%ILControlNumber, CREATE:Region , %ILParent)
   %ILControlNumber{PROP:Imm   } = TRUE
   %ILControlNumber{PROP:Use   } = %ILControlNumber
   %ILControlNumber{PROP:Height} = %ILControl{PROP:Height}
   %ILControlNumber{PROP:Width } = %ILControl{PROP:Width }
   %ILControlNumber{PROP:XPos  } = %ILControl{Prop:XPos  }
   %ILControlNumber{PROP:YPos  } = %ILControl{Prop:YPos  }
   %ILControlNumber{PROP:Hide  } = FALSE
   %ILControlNumber{PROP:Cursor} = '~hand.cur'
   #SET(%ILControlNumber,%ILControlNumber + 1)
#ENDFOR

InternetLinkEvents     Routine                !Handle HyperLink Events
#SET(%ILControlNumber,%ILControlStart)
#FOR(%ILControls)
 IF FIELD()=%ILControlNumber AND Event()=Event:MouseUp
   #IF(%ILLinkTo='HTML/FTP')
     #IF(SUB(%ILAddress,1,1)='!')
     #SET(%InternetVar,SUB(%ILAddress,2,100))
   URLHandler(%Window{prop:handle},CLIP(%InternetVar))
     #ELSE
   URLHandler(%Window{prop:handle},'%ILAddress')
     #ENDIF
   #ELSE
     #IF(SUB(%ILAddress,1,1)='!')
     #SET(%InternetVar,SUB(%ILAddress,2,100))
   URLHandler(%Window{prop:handle},'mailto:' & CLIP(%InternetVar))
     #ELSE
   URLHandler(%Window{prop:handle},'mailto:%ILAddress')
     #ENDIF
   #ENDIF
   EXIT
 END
   #SET(%ILControlNumber,%ILControlNumber + 1)
#ENDFOR
#ENDAT
#!--------------------------------------------------
#CONTROL(InternetLinkButton,'Internet Link Button Control')
   CONTROLS
       BUTTON('&InternetLink'),USE(?InternetLink)
   END
#BOXED('')
#PROMPT('Link To',OPTION),%BILLinkTo
#PROMPT('HTML/FTP',RADIO)
#PROMPT('E-Mail',RADIO)
#PROMPT('Address:',@S200),%BILAddress
#DISPLAY('Use a ! in front of a variable.')
#ENDBOXED

#ATSTART
  #DECLARE(%InternetVar)
  #DECLARE (%InternetLinkButton)
  #FOR (%Control), WHERE(%ControlInstance = %ActiveTemplateInstance)
    #SET (%InternetLinkButton, %Control)
  #ENDFOR
#ENDAT

#AT (%ControlEventHandling, %InternetLinkButton, 'Accepted')
   #IF(%BILLinkTo='HTML/FTP')
     #IF(SUB(%BILAddress,1,1)='!')
     #SET(%InternetVar,SUB(%BILAddress,2,100))
 URLHandler(%Window{prop:handle},CLIP(%InternetVar))
     #ELSE
 URLHandler(%Window{prop:handle},'%BILAddress')
     #ENDIF
   #ELSE
     #IF(SUB(%BILAddress,1,1)='!')
     #SET(%InternetVar,SUB(%BILAddress,2,100))
 URLHandler(%Window{prop:handle},'mailto:' & CLIP(%InternetVar))
     #ELSE
 URLHandler(%Window{prop:handle},'mailto:%BILAddress')
     #ENDIF
   #ENDIF
#ENDAT
#!--------------------------------------------------
#CODE(InternetLinkCode,'Internet Link Code Template')
#BOXED('')
#PROMPT('Link To',OPTION),%CILLinkTo
#PROMPT('HTML/FTP',RADIO)
#PROMPT('E-Mail',RADIO)
#PROMPT('Address:',@S200),%CILAddress
#DISPLAY('Use a ! in front of a variable.')
#ENDBOXED

#ATSTART
  #DECLARE(%InternetVar)
#ENDAT
   #IF(%CILLinkTo='HTML/FTP')
     #IF(SUB(%CILAddress,1,1)='!')
     #SET(%InternetVar,SUB(%CILAddress,2,100))
 URLHandler(%Window{prop:handle},CLIP(%InternetVar))
     #ELSE
 URLHandler(%Window{prop:handle},'%CILAddress')
     #ENDIF
   #ELSE
     #IF(SUB(%CILAddress,1,1)='!')
     #SET(%InternetVar,SUB(%CILAddress,2,100))
 URLHandler(%Window{prop:handle},'mailto:' & CLIP(%InternetVar))
     #ELSE
 URLHandler(%Window{prop:handle},'mailto:%CILAddress')
     #ENDIF
   #ENDIF


